import{s as Xn,o as Zn,n as ei}from"../chunks/scheduler.37c15a92.js";import{S as ti,i as ni,g as o,s as a,r as f,A as ii,h as s,f as n,c as r,j as Vn,u as p,x as l,k as Jn,y as ai,a as i,v as h,d as m,t as u,w as d,m as ri,n as oi}from"../chunks/index.2bf4358c.js";import{T as Kn}from"../chunks/Tip.363c041f.js";import{Q as je}from"../chunks/Question.668688bc.js";import{H as c,E as si}from"../chunks/EditOnGithub.8916dc7c.js";function li(We){let g;return{c(){g=ri("In this chapter, we are focusing on reinforcement learning for language models. However, reinforcement learning is a broad field with many applications beyond language models. If you're interested in learning more about reinforcement learning, you should check out the [Deep Reinforcement Learning course](https://huggingface.co/courses/deep-rl-course/en/unit1/introduction).")},l(v){g=oi(v,"In this chapter, we are focusing on reinforcement learning for language models. However, reinforcement learning is a broad field with many applications beyond language models. If you're interested in learning more about reinforcement learning, you should check out the [Deep Reinforcement Learning course](https://huggingface.co/courses/deep-rl-course/en/unit1/introduction).")},m(v,$){i(v,g,$)},d(v){v&&n(g)}}}function fi(We){let g,v="DPO and PPO are complex reinforcement learning algorithms in their own right, which we will not cover in this course. If you’re interested in learning more about them, you can check out the following resources:",$,x,y='<li><a href="https://huggingface.co/docs/trl/main/en/ppo_trainer" rel="nofollow">Proximal Policy Optimization</a></li> <li><a href="https://huggingface.co/docs/trl/main/en/dpo_trainer" rel="nofollow">Direct Preference Optimization</a></li>';return{c(){g=o("p"),g.textContent=v,$=a(),x=o("ul"),x.innerHTML=y},l(w){g=s(w,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1irn41k"&&(g.textContent=v),$=r(w),x=s(w,"UL",{"data-svelte-h":!0}),l(x)!=="svelte-1hp1bbe"&&(x.innerHTML=y)},m(w,L){i(w,g,L),i(w,$,L),i(w,x,L)},p:ei,d(w){w&&(n(g),n($),n(x))}}}function pi(We){let g,v,$,x,y,w,L,nn="Welcome to the first page!",Ae,R,an="We’re going to start our journey into the exciting world of Reinforcement Learning (RL) and discover how it’s revolutionizing the way we train Language Models like the ones you might use every day.",Ge,b,Ee,P,rn="This page will give you a friendly and clear introduction to RL, even if you’ve never encountered it before. We’ll break down the core ideas and see why RL is becoming so important in the field of Large Language Models (LLMs).",De,T,Se,k,on="Imagine you’re training a dog. You want to teach it to sit. You might say “Sit!” and then, if the dog sits, you give it a treat and praise. If it doesn’t sit, you might gently guide it or just try again. Over time, the dog learns to associate sitting with the positive reward (treat and praise) and is more likely to sit when you say “Sit!” again. In reinforcement learning, we refer to this feedback as a <strong>reward</strong>.",Ue,M,sn="That, in a nutshell, is the basic idea behind Reinforcement Learning! Instead of a dog, we have a <strong>language model</strong> (in reinforcement learning, we call it an <strong>agent</strong>), and instead of you, we have the <strong>environment</strong> that gives feedback.",Be,_,ln='<img src="https://huggingface.co/reasoning-course/images/resolve/main/grpo/3.jpg" alt="RL terms Process"/>',Ye,H,fn="Let’s break down the key pieces of RL:",Qe,O,Ne,F,pn="This is our learner. In the dog example, the dog is the agent. In the context of LLMs, the LLM itself becomes the agent we want to train. The agent is the one making decisions and learning from the environment and its rewards.",Ve,I,Je,q,hn="This is the world the agent lives in and interacts with. For the dog, the environment is your house and you. For an LLM, the environment is a bit more abstract – it could be the users it interacts with, or a simulated scenario we set up for it. The environment provides feedback to the agent.",Ke,W,Xe,z,mn="These are the choices the agent can make in the environment. The dog’s actions are things like “sit”, “stand”, “bark”, etc. For an LLM, actions could be generating words in a sentence, choosing which answer to give to a question, or deciding how to respond in a conversation.",Ze,j,et,A,un="This is the feedback the environment gives to the agent after it takes an action. Rewards are usually numbers.",tt,G,dn="<strong>Positive rewards</strong> are like treats and praise – they tell the agent “good job, you did something right!“.",nt,E,gn="<strong>Negative rewards</strong> (or penalties) are like a gentle “no” – they tell the agent “that wasn’t quite right, try something else”. For the dog, the treat is the reward.",it,D,cn="For an LLM, rewards are designed to reflect how well the LLM is doing at a specific task – maybe it’s how helpful, truthful, or harmless its response is.",at,S,rt,U,wn="This is the agent’s strategy for choosing actions. It’s like the dog’s understanding of what it should do when you say “Sit!“. In RL, the policy is what we’re really trying to learn and improve. It’s a set of rules or a function that tells the agent what action to take in different situations. Initially, the policy might be random, but as the agent learns, the policy becomes better at choosing actions that lead to higher rewards.",ot,B,st,Y,vn='<img src="https://huggingface.co/reasoning-course/images/resolve/main/grpo/1.jpg" alt="RL Process"/>',lt,Q,$n="Reinforcement Learning happens through a process of trial and error:",ft,N,xn="<thead><tr><th>Step</th> <th>Process</th> <th>Description</th></tr></thead> <tbody><tr><td>1. Observation</td> <td>The agent observes the environment</td> <td>The agent takes in information about its current state and surroundings</td></tr> <tr><td>2. Action</td> <td>The agent takes an action based on its current policy</td> <td>Using its learned strategy (policy), the agent decides what to do next</td></tr> <tr><td>3. Feedback</td> <td>The environment gives the agent a reward</td> <td>The agent receives feedback on how good or bad its action was</td></tr> <tr><td>4. Learning</td> <td>The agent updates its policy based on the reward</td> <td>The agent adjusts its strategy - reinforcing actions that led to high rewards and avoiding those that led low rewards</td></tr> <tr><td>5. Iteration</td> <td>Repeat the process</td> <td>This cycle continues, allowing the agent to continuously improve its decision-making</td></tr></tbody>",pt,V,Ln="Think about learning to ride a bike. You might wobble and fall at first (negative reward!). But when you manage to balance and pedal smoothly, you feel good (positive reward!). You adjust your actions based on this feedback – leaning slightly, pedaling faster, etc. – until you learn to ride well. RL is similar – it’s about learning through interaction and feedback.",ht,J,mt,K,yn="Now, why is RL so important for Large Language Models?",ut,X,bn='Well, training really good LLMs is tricky. We can train them on massive amounts of text from the internet, and they become very good at predicting the next word in a sentence. This is how they learn to generate fluent and grammatically correct text, as we learned in <a href="/chapters/en/chapter2/1">chapter 2</a>.',dt,Z,Cn="However, just being fluent isn’t enough. We want our LLMs to be more than just good at stringing words together. We want them to be:",gt,ee,Rn="<li><strong>Helpful:</strong> Provide useful and relevant information.</li> <li><strong>Harmless:</strong> Avoid generating toxic, biased, or harmful content.</li> <li><strong>Aligned with Human Preferences:</strong> Respond in ways that humans find natural, helpful, and engaging.</li>",ct,te,Pn="Pre-training LLM methods, which mostly rely on predicting the next word from text data, sometimes fall short on these aspects.",wt,ne,Tn='Whilst supervised training is excellent at producing structured outputs, it can be less effective at producing helpful, harmless, and aligned responses. We explore supervised training in <a href="/chapters/en/chapter11/1">chapter 11</a>.',vt,ie,kn="Fine-tuned models might generate fluent and structured text that is still factually incorrect, biased, or doesn’t really answer the user’s question in a helpful way.",$t,ae,Mn="<strong>Enter Reinforcement Learning!</strong> RL gives us a way to fine-tune these pre-trained LLMs to better achieve these desired qualities. It’s like giving our LLM dog extra training to become a well-behaved and helpful companion, not just a dog that knows how to bark fluently!",xt,re,Lt,oe,_n="A very popular technique for aligning language models is <strong>Reinforcement Learning from Human Feedback (RLHF)</strong>. In RLHF, we use human feedback as a proxy for the “reward” signal in RL. Here’s how it works:",yt,se,Hn="<li><p><strong>Get Human Preferences:</strong> We might ask humans to compare different responses generated by the LLM for the same input prompt and tell us which response they prefer. For example, we might show a human two different answers to the question “What is the capital of France?” and ask them “Which answer is better?“.</p></li> <li><p><strong>Train a Reward Model:</strong> We use this human preference data to train a separate model called a <strong>reward model</strong>. This reward model learns to predict what kind of responses humans will prefer. It learns to score responses based on helpfulness, harmlessness, and alignment with human preferences.</p></li> <li><p><strong>Fine-tune the LLM with RL:</strong> Now we use the reward model as the environment for our LLM agent. The LLM generates responses (actions), and the reward model scores these responses (provides rewards). In essence, we’re training the LLM to produce text that our reward model (which learned from human preferences) thinks is good.</p></li>",bt,le,On='<img src="https://huggingface.co/reasoning-course/images/resolve/main/grpo/2.jpg" alt="RL Basic Concept"/>',Ct,fe,Fn="From a general perspective, let’s look at the benefits of using RL in LLMs:",Rt,pe,In="<thead><tr><th>Benefit</th> <th>Description</th></tr></thead> <tbody><tr><td>Improved Control</td> <td>RL allows us to have more control over the kind of text LLMs generate. We can guide them to produce text that is more aligned with specific goals, like being helpful, creative, or concise.</td></tr> <tr><td>Enhanced Alignment with Human Values</td> <td>RLHF, in particular, helps us align LLMs with complex and often subjective human preferences. It’s hard to write down rules for “what makes a good answer,” but humans can easily judge and compare responses. RLHF lets the model learn from these human judgments.</td></tr> <tr><td>Mitigating Undesirable Behaviors</td> <td>RL can be used to reduce negative behaviors in LLMs, such as generating toxic language, spreading misinformation, or exhibiting biases. By designing rewards that penalize these behaviors, we can nudge the model to avoid them.</td></tr></tbody>",Pt,he,qn="Reinforcement Learning from Human Feedback has been used to train many of the most popular LLMs today, such as OpenAI’s GPT-4, Google’s Gemini, and DeepSeek’s R1. There are a wide range of techniques for RLHF, with varying degrees of complexity and sophistication. In this chapter, we will focus on Group Relative Policy Optimization (GRPO), which is a technique for RLHF that has been shown to be effective at training LLMs that are helpful, harmless, and aligned with human preferences.",Tt,me,kt,ue,Wn="There are many techniques for RLHF but this course is focused on GRPO because it represents a significant advancement in reinforcement learning for language models.",Mt,de,zn="Let’s briefly consider two of other popular techniques for RLHF:",_t,ge,jn="<li>Proximal Policy Optimization (PPO)</li> <li>Direct Preference Optimization (DPO)</li>",Ht,ce,An="Proximal Policy Optimization (PPO) was one of the first highly effective techniques for RLHF. It uses a policy gradient method to update the policy based on the reward from a separate reward model.",Ot,we,Gn="Direct Preference Optimization (DPO) was later developed as a simpler technique that eliminates the need for a separate reward model using preference data directly. Essentially, framing the problem as a classification task between the chosen and rejected responses.",Ft,C,It,ve,En="Unlike DPO and PPO, GRPO groups similar samples together and compares them as a group. The group-based approach provides more stable gradients and better convergence properties compared to other methods.",qt,$e,Dn="GRPO does not use preference data like DPO, but instead compares groups of similar samples using a reward signal from a model or function.",Wt,xe,Sn="GRPO is flexible in how it obtains reward signals - it can work with a reward model (like PPO does) but doesn’t strictly require one. This is because GRPO can incorporate reward signals from any function or model that can evaluate the quality of responses.",zt,Le,Un="For example, we could use a length function to reward shorter responses, a mathematical solver to verify solution correctness, or a factual correctness function to reward responses that are more factually accurate. This flexibility makes GRPO particularly versatile for different types of alignment tasks.",jt,At,Gt,ye,Bn="Congratulations on completing Module 1! You’ve now got a solid introduction to Reinforcement Learning and its crucial role in shaping the future of Large Language Models. You understand the basic concepts of RL, why it’s used for LLMs, and you’ve been introduced to GRPO, a key algorithm in this field.",Et,be,Yn="In the next module, we’ll get our hands dirty and dive into the DeepSeek R1 paper to see these concepts in action!",Dt,Ce,St,Re,Ut,Pe,Bt,Te,Yt,ke,Qt,Me,Nt,_e,Vt,He,Jt,Oe,Kt,Fe,Xt,Ie,Zt,qe,en,ze,tn;return y=new c({props:{title:"Introduction to Reinforcement Learning and its Role in LLMs",local:"introduction-to-reinforcement-learning-and-its-role-in-llms",headingTag:"h1"}}),b=new Kn({props:{$$slots:{default:[li]},$$scope:{ctx:We}}}),T=new c({props:{title:"What is Reinforcement Learning (RL)?",local:"what-is-reinforcement-learning-rl",headingTag:"h2"}}),O=new c({props:{title:"Agent",local:"agent",headingTag:"h3"}}),I=new c({props:{title:"Environment",local:"environment",headingTag:"h3"}}),W=new c({props:{title:"Action",local:"action",headingTag:"h3"}}),j=new c({props:{title:"Reward",local:"reward",headingTag:"h3"}}),S=new c({props:{title:"Policy",local:"policy",headingTag:"h3"}}),B=new c({props:{title:"The RL Process: Trial and Error",local:"the-rl-process-trial-and-error",headingTag:"h2"}}),J=new c({props:{title:"Role of RL in Large Language Models (LLMs)",local:"role-of-rl-in-large-language-models-llms",headingTag:"h2"}}),re=new c({props:{title:"Reinforcement Learning from Human Feedback (RLHF)",local:"reinforcement-learning-from-human-feedback-rlhf",headingTag:"h2"}}),me=new c({props:{title:"Why should we care about GRPO (Group Relative Policy Optimization)?",local:"why-should-we-care-about-grpo-group-relative-policy-optimization",headingTag:"h2"}}),C=new Kn({props:{$$slots:{default:[fi]},$$scope:{ctx:We}}}),Ce=new c({props:{title:"Quiz",local:"quiz",headingTag:"h2"}}),Re=new c({props:{title:"1. What are the key components of Reinforcement Learning?",local:"1-what-are-the-key-components-of-reinforcement-learning",headingTag:"h3"}}),Pe=new je({props:{choices:[{text:"Agent, Environment, Action, Reward, and Policy",explain:"Correct! These are the fundamental components that make up a reinforcement learning system.",correct:!0},{text:"Model, Data, Loss Function, and Optimizer",explain:"These are components more commonly associated with supervised learning."},{text:"Input, Output, and Hidden Layers",explain:"These are components of neural network architecture, not specifically RL components."}]}}),Te=new c({props:{title:"2. What is the main advantage of RLHF for training language models?",local:"2-what-is-the-main-advantage-of-rlhf-for-training-language-models",headingTag:"h3"}}),ke=new je({props:{choices:[{text:"It helps align models with human preferences and values",explain:"Correct! RLHF uses human feedback to guide models toward more helpful, harmless, and aligned behavior.",correct:!0},{text:"It makes models generate text faster",explain:"RLHF isn't primarily about improving generation speed."},{text:"It reduces the model's memory usage",explain:"RLHF doesn't focus on model efficiency or memory optimization."}]}}),Me=new c({props:{title:"3. In the context of RL for LLMs, what represents an “action”?",local:"3-in-the-context-of-rl-for-llms-what-represents-an-action",headingTag:"h3"}}),_e=new je({props:{choices:[{text:"Generating words or choosing responses in a conversation",explain:"Correct! For LLMs, actions typically involve text generation decisions.",correct:!0},{text:"Updating model weights",explain:"This is part of the training process, not an action in the RL context."},{text:"Processing input tokens",explain:"This is part of the model's operation, not an action in the RL context."}]}}),He=new c({props:{title:"4. What is the role of the reward in RL training of language models?",local:"4-what-is-the-role-of-the-reward-in-rl-training-of-language-models",headingTag:"h3"}}),Oe=new je({props:{choices:[{text:"To provide feedback on how well the model's responses align with desired behavior",explain:"Correct! Rewards guide the model toward generating more helpful, truthful, and appropriate responses.",correct:!0},{text:"To measure the model's vocabulary size",explain:"Rewards aren't used to evaluate vocabulary knowledge."},{text:"To determine the model's training speed",explain:"Rewards provide feedback on response quality, not training efficiency."}]}}),Fe=new c({props:{title:"5. What is a reward in the context of RL for LLMs?",local:"5-what-is-a-reward-in-the-context-of-rl-for-llms",headingTag:"h3"}}),Ie=new je({props:{choices:[{text:"A numerical score that measures the quality of a response",explain:"Correct! Rewards provide feedback on response quality, guiding the model toward desired behavior.",correct:!0},{text:"A function that generates responses",explain:"Rewards are feedback on response quality, not the generation process itself."},{text:"A model that evaluates the quality of responses",explain:"Rewards are feedback on response quality, not an evaluation model."}]}}),qe=new si({props:{source:"https://github.com/huggingface/course/blob/main/chapters/en/chapter12/2.mdx"}}),{c(){g=o("meta"),v=a(),$=o("p"),x=a(),f(y.$$.fragment),w=a(),L=o("p"),L.textContent=nn,Ae=a(),R=o("p"),R.textContent=an,Ge=a(),f(b.$$.fragment),Ee=a(),P=o("p"),P.textContent=rn,De=a(),f(T.$$.fragment),Se=a(),k=o("p"),k.innerHTML=on,Ue=a(),M=o("p"),M.innerHTML=sn,Be=a(),_=o("p"),_.innerHTML=ln,Ye=a(),H=o("p"),H.textContent=fn,Qe=a(),f(O.$$.fragment),Ne=a(),F=o("p"),F.textContent=pn,Ve=a(),f(I.$$.fragment),Je=a(),q=o("p"),q.textContent=hn,Ke=a(),f(W.$$.fragment),Xe=a(),z=o("p"),z.textContent=mn,Ze=a(),f(j.$$.fragment),et=a(),A=o("p"),A.textContent=un,tt=a(),G=o("p"),G.innerHTML=dn,nt=a(),E=o("p"),E.innerHTML=gn,it=a(),D=o("p"),D.textContent=cn,at=a(),f(S.$$.fragment),rt=a(),U=o("p"),U.textContent=wn,ot=a(),f(B.$$.fragment),st=a(),Y=o("p"),Y.innerHTML=vn,lt=a(),Q=o("p"),Q.textContent=$n,ft=a(),N=o("table"),N.innerHTML=xn,pt=a(),V=o("p"),V.textContent=Ln,ht=a(),f(J.$$.fragment),mt=a(),K=o("p"),K.textContent=yn,ut=a(),X=o("p"),X.innerHTML=bn,dt=a(),Z=o("p"),Z.textContent=Cn,gt=a(),ee=o("ul"),ee.innerHTML=Rn,ct=a(),te=o("p"),te.textContent=Pn,wt=a(),ne=o("p"),ne.innerHTML=Tn,vt=a(),ie=o("p"),ie.textContent=kn,$t=a(),ae=o("p"),ae.innerHTML=Mn,xt=a(),f(re.$$.fragment),Lt=a(),oe=o("p"),oe.innerHTML=_n,yt=a(),se=o("ol"),se.innerHTML=Hn,bt=a(),le=o("p"),le.innerHTML=On,Ct=a(),fe=o("p"),fe.textContent=Fn,Rt=a(),pe=o("table"),pe.innerHTML=In,Pt=a(),he=o("p"),he.textContent=qn,Tt=a(),f(me.$$.fragment),kt=a(),ue=o("p"),ue.textContent=Wn,Mt=a(),de=o("p"),de.textContent=zn,_t=a(),ge=o("ul"),ge.innerHTML=jn,Ht=a(),ce=o("p"),ce.textContent=An,Ot=a(),we=o("p"),we.textContent=Gn,Ft=a(),f(C.$$.fragment),It=a(),ve=o("p"),ve.textContent=En,qt=a(),$e=o("p"),$e.textContent=Dn,Wt=a(),xe=o("p"),xe.textContent=Sn,zt=a(),Le=o("p"),Le.textContent=Un,jt=a(),At=o("hr"),Gt=a(),ye=o("p"),ye.textContent=Bn,Et=a(),be=o("p"),be.textContent=Yn,Dt=a(),f(Ce.$$.fragment),St=a(),f(Re.$$.fragment),Ut=a(),f(Pe.$$.fragment),Bt=a(),f(Te.$$.fragment),Yt=a(),f(ke.$$.fragment),Qt=a(),f(Me.$$.fragment),Nt=a(),f(_e.$$.fragment),Vt=a(),f(He.$$.fragment),Jt=a(),f(Oe.$$.fragment),Kt=a(),f(Fe.$$.fragment),Xt=a(),f(Ie.$$.fragment),Zt=a(),f(qe.$$.fragment),en=a(),ze=o("p"),this.h()},l(e){const t=ii("svelte-u9bgzb",document.head);g=s(t,"META",{name:!0,content:!0}),t.forEach(n),v=r(e),$=s(e,"P",{}),Vn($).forEach(n),x=r(e),p(y.$$.fragment,e),w=r(e),L=s(e,"P",{"data-svelte-h":!0}),l(L)!=="svelte-cir3ne"&&(L.textContent=nn),Ae=r(e),R=s(e,"P",{"data-svelte-h":!0}),l(R)!=="svelte-bu5wvy"&&(R.textContent=an),Ge=r(e),p(b.$$.fragment,e),Ee=r(e),P=s(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-slvo6d"&&(P.textContent=rn),De=r(e),p(T.$$.fragment,e),Se=r(e),k=s(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-zixz1p"&&(k.innerHTML=on),Ue=r(e),M=s(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-12ibefg"&&(M.innerHTML=sn),Be=r(e),_=s(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-sy5vgw"&&(_.innerHTML=ln),Ye=r(e),H=s(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-1iaj6ti"&&(H.textContent=fn),Qe=r(e),p(O.$$.fragment,e),Ne=r(e),F=s(e,"P",{"data-svelte-h":!0}),l(F)!=="svelte-yob3xl"&&(F.textContent=pn),Ve=r(e),p(I.$$.fragment,e),Je=r(e),q=s(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-1veabrk"&&(q.textContent=hn),Ke=r(e),p(W.$$.fragment,e),Xe=r(e),z=s(e,"P",{"data-svelte-h":!0}),l(z)!=="svelte-2rjcti"&&(z.textContent=mn),Ze=r(e),p(j.$$.fragment,e),et=r(e),A=s(e,"P",{"data-svelte-h":!0}),l(A)!=="svelte-1qcqexo"&&(A.textContent=un),tt=r(e),G=s(e,"P",{"data-svelte-h":!0}),l(G)!=="svelte-utdwbs"&&(G.innerHTML=dn),nt=r(e),E=s(e,"P",{"data-svelte-h":!0}),l(E)!=="svelte-11duu8f"&&(E.innerHTML=gn),it=r(e),D=s(e,"P",{"data-svelte-h":!0}),l(D)!=="svelte-4rbpl1"&&(D.textContent=cn),at=r(e),p(S.$$.fragment,e),rt=r(e),U=s(e,"P",{"data-svelte-h":!0}),l(U)!=="svelte-1jv6l0y"&&(U.textContent=wn),ot=r(e),p(B.$$.fragment,e),st=r(e),Y=s(e,"P",{"data-svelte-h":!0}),l(Y)!=="svelte-t8x49h"&&(Y.innerHTML=vn),lt=r(e),Q=s(e,"P",{"data-svelte-h":!0}),l(Q)!=="svelte-73ben5"&&(Q.textContent=$n),ft=r(e),N=s(e,"TABLE",{"data-svelte-h":!0}),l(N)!=="svelte-4hnhaa"&&(N.innerHTML=xn),pt=r(e),V=s(e,"P",{"data-svelte-h":!0}),l(V)!=="svelte-wet5s9"&&(V.textContent=Ln),ht=r(e),p(J.$$.fragment,e),mt=r(e),K=s(e,"P",{"data-svelte-h":!0}),l(K)!=="svelte-2nnkb3"&&(K.textContent=yn),ut=r(e),X=s(e,"P",{"data-svelte-h":!0}),l(X)!=="svelte-59sj0k"&&(X.innerHTML=bn),dt=r(e),Z=s(e,"P",{"data-svelte-h":!0}),l(Z)!=="svelte-1f12e0u"&&(Z.textContent=Cn),gt=r(e),ee=s(e,"UL",{"data-svelte-h":!0}),l(ee)!=="svelte-12mjlhm"&&(ee.innerHTML=Rn),ct=r(e),te=s(e,"P",{"data-svelte-h":!0}),l(te)!=="svelte-fggtyf"&&(te.textContent=Pn),wt=r(e),ne=s(e,"P",{"data-svelte-h":!0}),l(ne)!=="svelte-ao9cj7"&&(ne.innerHTML=Tn),vt=r(e),ie=s(e,"P",{"data-svelte-h":!0}),l(ie)!=="svelte-l992q4"&&(ie.textContent=kn),$t=r(e),ae=s(e,"P",{"data-svelte-h":!0}),l(ae)!=="svelte-13h0geo"&&(ae.innerHTML=Mn),xt=r(e),p(re.$$.fragment,e),Lt=r(e),oe=s(e,"P",{"data-svelte-h":!0}),l(oe)!=="svelte-vbayee"&&(oe.innerHTML=_n),yt=r(e),se=s(e,"OL",{"data-svelte-h":!0}),l(se)!=="svelte-13rt60o"&&(se.innerHTML=Hn),bt=r(e),le=s(e,"P",{"data-svelte-h":!0}),l(le)!=="svelte-20078t"&&(le.innerHTML=On),Ct=r(e),fe=s(e,"P",{"data-svelte-h":!0}),l(fe)!=="svelte-1ljlbgz"&&(fe.textContent=Fn),Rt=r(e),pe=s(e,"TABLE",{"data-svelte-h":!0}),l(pe)!=="svelte-omrei2"&&(pe.innerHTML=In),Pt=r(e),he=s(e,"P",{"data-svelte-h":!0}),l(he)!=="svelte-cocpof"&&(he.textContent=qn),Tt=r(e),p(me.$$.fragment,e),kt=r(e),ue=s(e,"P",{"data-svelte-h":!0}),l(ue)!=="svelte-1toktt4"&&(ue.textContent=Wn),Mt=r(e),de=s(e,"P",{"data-svelte-h":!0}),l(de)!=="svelte-1kk40pt"&&(de.textContent=zn),_t=r(e),ge=s(e,"UL",{"data-svelte-h":!0}),l(ge)!=="svelte-19pdi9y"&&(ge.innerHTML=jn),Ht=r(e),ce=s(e,"P",{"data-svelte-h":!0}),l(ce)!=="svelte-1uprfeu"&&(ce.textContent=An),Ot=r(e),we=s(e,"P",{"data-svelte-h":!0}),l(we)!=="svelte-gtn9pd"&&(we.textContent=Gn),Ft=r(e),p(C.$$.fragment,e),It=r(e),ve=s(e,"P",{"data-svelte-h":!0}),l(ve)!=="svelte-1r71chc"&&(ve.textContent=En),qt=r(e),$e=s(e,"P",{"data-svelte-h":!0}),l($e)!=="svelte-172rnsv"&&($e.textContent=Dn),Wt=r(e),xe=s(e,"P",{"data-svelte-h":!0}),l(xe)!=="svelte-azw8h4"&&(xe.textContent=Sn),zt=r(e),Le=s(e,"P",{"data-svelte-h":!0}),l(Le)!=="svelte-hlmg2x"&&(Le.textContent=Un),jt=r(e),At=s(e,"HR",{}),Gt=r(e),ye=s(e,"P",{"data-svelte-h":!0}),l(ye)!=="svelte-ax6i43"&&(ye.textContent=Bn),Et=r(e),be=s(e,"P",{"data-svelte-h":!0}),l(be)!=="svelte-1k1hoix"&&(be.textContent=Yn),Dt=r(e),p(Ce.$$.fragment,e),St=r(e),p(Re.$$.fragment,e),Ut=r(e),p(Pe.$$.fragment,e),Bt=r(e),p(Te.$$.fragment,e),Yt=r(e),p(ke.$$.fragment,e),Qt=r(e),p(Me.$$.fragment,e),Nt=r(e),p(_e.$$.fragment,e),Vt=r(e),p(He.$$.fragment,e),Jt=r(e),p(Oe.$$.fragment,e),Kt=r(e),p(Fe.$$.fragment,e),Xt=r(e),p(Ie.$$.fragment,e),Zt=r(e),p(qe.$$.fragment,e),en=r(e),ze=s(e,"P",{}),Vn(ze).forEach(n),this.h()},h(){Jn(g,"name","hf:doc:metadata"),Jn(g,"content",hi)},m(e,t){ai(document.head,g),i(e,v,t),i(e,$,t),i(e,x,t),h(y,e,t),i(e,w,t),i(e,L,t),i(e,Ae,t),i(e,R,t),i(e,Ge,t),h(b,e,t),i(e,Ee,t),i(e,P,t),i(e,De,t),h(T,e,t),i(e,Se,t),i(e,k,t),i(e,Ue,t),i(e,M,t),i(e,Be,t),i(e,_,t),i(e,Ye,t),i(e,H,t),i(e,Qe,t),h(O,e,t),i(e,Ne,t),i(e,F,t),i(e,Ve,t),h(I,e,t),i(e,Je,t),i(e,q,t),i(e,Ke,t),h(W,e,t),i(e,Xe,t),i(e,z,t),i(e,Ze,t),h(j,e,t),i(e,et,t),i(e,A,t),i(e,tt,t),i(e,G,t),i(e,nt,t),i(e,E,t),i(e,it,t),i(e,D,t),i(e,at,t),h(S,e,t),i(e,rt,t),i(e,U,t),i(e,ot,t),h(B,e,t),i(e,st,t),i(e,Y,t),i(e,lt,t),i(e,Q,t),i(e,ft,t),i(e,N,t),i(e,pt,t),i(e,V,t),i(e,ht,t),h(J,e,t),i(e,mt,t),i(e,K,t),i(e,ut,t),i(e,X,t),i(e,dt,t),i(e,Z,t),i(e,gt,t),i(e,ee,t),i(e,ct,t),i(e,te,t),i(e,wt,t),i(e,ne,t),i(e,vt,t),i(e,ie,t),i(e,$t,t),i(e,ae,t),i(e,xt,t),h(re,e,t),i(e,Lt,t),i(e,oe,t),i(e,yt,t),i(e,se,t),i(e,bt,t),i(e,le,t),i(e,Ct,t),i(e,fe,t),i(e,Rt,t),i(e,pe,t),i(e,Pt,t),i(e,he,t),i(e,Tt,t),h(me,e,t),i(e,kt,t),i(e,ue,t),i(e,Mt,t),i(e,de,t),i(e,_t,t),i(e,ge,t),i(e,Ht,t),i(e,ce,t),i(e,Ot,t),i(e,we,t),i(e,Ft,t),h(C,e,t),i(e,It,t),i(e,ve,t),i(e,qt,t),i(e,$e,t),i(e,Wt,t),i(e,xe,t),i(e,zt,t),i(e,Le,t),i(e,jt,t),i(e,At,t),i(e,Gt,t),i(e,ye,t),i(e,Et,t),i(e,be,t),i(e,Dt,t),h(Ce,e,t),i(e,St,t),h(Re,e,t),i(e,Ut,t),h(Pe,e,t),i(e,Bt,t),h(Te,e,t),i(e,Yt,t),h(ke,e,t),i(e,Qt,t),h(Me,e,t),i(e,Nt,t),h(_e,e,t),i(e,Vt,t),h(He,e,t),i(e,Jt,t),h(Oe,e,t),i(e,Kt,t),h(Fe,e,t),i(e,Xt,t),h(Ie,e,t),i(e,Zt,t),h(qe,e,t),i(e,en,t),i(e,ze,t),tn=!0},p(e,[t]){const Qn={};t&2&&(Qn.$$scope={dirty:t,ctx:e}),b.$set(Qn);const Nn={};t&2&&(Nn.$$scope={dirty:t,ctx:e}),C.$set(Nn)},i(e){tn||(m(y.$$.fragment,e),m(b.$$.fragment,e),m(T.$$.fragment,e),m(O.$$.fragment,e),m(I.$$.fragment,e),m(W.$$.fragment,e),m(j.$$.fragment,e),m(S.$$.fragment,e),m(B.$$.fragment,e),m(J.$$.fragment,e),m(re.$$.fragment,e),m(me.$$.fragment,e),m(C.$$.fragment,e),m(Ce.$$.fragment,e),m(Re.$$.fragment,e),m(Pe.$$.fragment,e),m(Te.$$.fragment,e),m(ke.$$.fragment,e),m(Me.$$.fragment,e),m(_e.$$.fragment,e),m(He.$$.fragment,e),m(Oe.$$.fragment,e),m(Fe.$$.fragment,e),m(Ie.$$.fragment,e),m(qe.$$.fragment,e),tn=!0)},o(e){u(y.$$.fragment,e),u(b.$$.fragment,e),u(T.$$.fragment,e),u(O.$$.fragment,e),u(I.$$.fragment,e),u(W.$$.fragment,e),u(j.$$.fragment,e),u(S.$$.fragment,e),u(B.$$.fragment,e),u(J.$$.fragment,e),u(re.$$.fragment,e),u(me.$$.fragment,e),u(C.$$.fragment,e),u(Ce.$$.fragment,e),u(Re.$$.fragment,e),u(Pe.$$.fragment,e),u(Te.$$.fragment,e),u(ke.$$.fragment,e),u(Me.$$.fragment,e),u(_e.$$.fragment,e),u(He.$$.fragment,e),u(Oe.$$.fragment,e),u(Fe.$$.fragment,e),u(Ie.$$.fragment,e),u(qe.$$.fragment,e),tn=!1},d(e){e&&(n(v),n($),n(x),n(w),n(L),n(Ae),n(R),n(Ge),n(Ee),n(P),n(De),n(Se),n(k),n(Ue),n(M),n(Be),n(_),n(Ye),n(H),n(Qe),n(Ne),n(F),n(Ve),n(Je),n(q),n(Ke),n(Xe),n(z),n(Ze),n(et),n(A),n(tt),n(G),n(nt),n(E),n(it),n(D),n(at),n(rt),n(U),n(ot),n(st),n(Y),n(lt),n(Q),n(ft),n(N),n(pt),n(V),n(ht),n(mt),n(K),n(ut),n(X),n(dt),n(Z),n(gt),n(ee),n(ct),n(te),n(wt),n(ne),n(vt),n(ie),n($t),n(ae),n(xt),n(Lt),n(oe),n(yt),n(se),n(bt),n(le),n(Ct),n(fe),n(Rt),n(pe),n(Pt),n(he),n(Tt),n(kt),n(ue),n(Mt),n(de),n(_t),n(ge),n(Ht),n(ce),n(Ot),n(we),n(Ft),n(It),n(ve),n(qt),n($e),n(Wt),n(xe),n(zt),n(Le),n(jt),n(At),n(Gt),n(ye),n(Et),n(be),n(Dt),n(St),n(Ut),n(Bt),n(Yt),n(Qt),n(Nt),n(Vt),n(Jt),n(Kt),n(Xt),n(Zt),n(en),n(ze)),n(g),d(y,e),d(b,e),d(T,e),d(O,e),d(I,e),d(W,e),d(j,e),d(S,e),d(B,e),d(J,e),d(re,e),d(me,e),d(C,e),d(Ce,e),d(Re,e),d(Pe,e),d(Te,e),d(ke,e),d(Me,e),d(_e,e),d(He,e),d(Oe,e),d(Fe,e),d(Ie,e),d(qe,e)}}}const hi='{"title":"Introduction to Reinforcement Learning and its Role in LLMs","local":"introduction-to-reinforcement-learning-and-its-role-in-llms","sections":[{"title":"What is Reinforcement Learning (RL)?","local":"what-is-reinforcement-learning-rl","sections":[{"title":"Agent","local":"agent","sections":[],"depth":3},{"title":"Environment","local":"environment","sections":[],"depth":3},{"title":"Action","local":"action","sections":[],"depth":3},{"title":"Reward","local":"reward","sections":[],"depth":3},{"title":"Policy","local":"policy","sections":[],"depth":3}],"depth":2},{"title":"The RL Process: Trial and Error","local":"the-rl-process-trial-and-error","sections":[],"depth":2},{"title":"Role of RL in Large Language Models (LLMs)","local":"role-of-rl-in-large-language-models-llms","sections":[],"depth":2},{"title":"Reinforcement Learning from Human Feedback (RLHF)","local":"reinforcement-learning-from-human-feedback-rlhf","sections":[],"depth":2},{"title":"Why should we care about GRPO (Group Relative Policy Optimization)?","local":"why-should-we-care-about-grpo-group-relative-policy-optimization","sections":[],"depth":2},{"title":"Quiz","local":"quiz","sections":[{"title":"1. What are the key components of Reinforcement Learning?","local":"1-what-are-the-key-components-of-reinforcement-learning","sections":[],"depth":3},{"title":"2. What is the main advantage of RLHF for training language models?","local":"2-what-is-the-main-advantage-of-rlhf-for-training-language-models","sections":[],"depth":3},{"title":"3. In the context of RL for LLMs, what represents an “action”?","local":"3-in-the-context-of-rl-for-llms-what-represents-an-action","sections":[],"depth":3},{"title":"4. What is the role of the reward in RL training of language models?","local":"4-what-is-the-role-of-the-reward-in-rl-training-of-language-models","sections":[],"depth":3},{"title":"5. What is a reward in the context of RL for LLMs?","local":"5-what-is-a-reward-in-the-context-of-rl-for-llms","sections":[],"depth":3}],"depth":2}],"depth":1}';function mi(We){return Zn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vi extends ti{constructor(g){super(),ni(this,g,mi,pi,Xn,{})}}export{vi as component};
